/*****************************************************************************

		Copyright (c) 1984 - 2000 Prolog Development Center A/S

 Project:  SEN_AN
 FileName: SEN_AN.PRO
 Purpose: No description
 Written by: Visual Prolog
 Comments:
******************************************************************************/



facts - senan_db 				
  det(string)
  noun(string)
  rel(string)
  verb(string)

domains						
  DETERM	= none;
  		  determ(string)
  NOUNP		= nounp(DETERM,string,RELCL)
  RELCL		= none;
  		  relcl(string,VERBP)
  SENTENCE	= sent(NOUNP,VERBP)
  VERBP		=verb(string);
		  verbp(string,NOUNP)
  TOKL		= string*			

predicates					

  is_det(string)
  is_noun(string)
  is_rel(string)
  is_verb(string)
  is_quel(string,string)

is_perebor(string,string,string)

  nondeterm s_determ(TOKL,TOKL,DETERM)
  nondeterm s_nounp(TOKL,TOKL,NOUNP)
  nondeterm s_relcl(TOKL,TOKL,RELCL)
  nondeterm s_sentence(TOKL,TOKL,SENTENCE)
  nondeterm s_verbp(TOKL,TOKL,VERBP)


  check(string)
  tokl(string,TOKL)
	
clauses						
						


  s_sentence(TOKL,TOKL2,sent(NOUNP,VERBP)):- 	
	s_nounp(TOKL,TOKL1,NOUNP),			
	s_verbp(TOKL1,TOKL2,VERBP),		
	TOKL2=[],				
	!.					
  s_sentence(_,_,_):-
	write(">> Sentence not recognized\n"),	
	fail.

  s_nounp(TOKL,TOKL2,nounp(DETERM,NOUN,RELCL)):-
	s_determ(TOKL,[NOUN|TOKL1],DETERM),	
	is_noun(NOUN),				
	s_relcl(TOKL1,TOKL2,RELCL).		

  s_determ([DETERM|TOKL],TOKL,determ(DETERM)):- 
	is_det(DETERM).				
  s_determ(TOKL,TOKL,none).			

  s_relcl([REL|TOKL],TOKL1,relcl(REL,VERBP)):-	
	is_rel(REL),					
	s_verbp(TOKL,TOKL1,VERBP).			
  s_relcl(TOKL,TOKL,none).
 	

  s_verbp([VERB|TOKL],TOKL1,verbp(VERB,NOUNP)):-
	is_verb(VERB),				
	s_nounp(TOKL,TOKL1,NOUNP).
	
  s_verbp([VERB|TOKL],TOKL,verb(VERB)):-	
	is_verb(VERB).				

  is_noun(X):-										
	noun(X),			
	!.				
  is_noun(X):-				
	noun(Y),			
	concat(Y,"s",X),
	!.

  is_det(X):-				
	det(X),
	!.
  is_quel(X,STR10):-	
  	noun(X),		
	not(X<>STR10),
	!.

  is_rel(X):-				
	rel(X),
	!.

  is_verb(X):-				
	verb(X),
	!.
  is_verb(X):-				
	verb(Y),
	concat(Y,"s",X),
	!.
  is_verb(X):-
	verb(Y),
	concat(Y,"ed",X),
	!.
  is_verb(X):-
	verb(Y),
	concat(Y,"es",X),
	!.
  is_verb(X):-
	verb(Y),
	concat(Y,"ing",X),
	!.
	
  is_perebor(STR, TERM,STR10):-
   fronttoken(STR,_,TOKl0),
    fronttoken(TOKl0,TOK1,TOKl2),
      is_quel(TOK1,STR10),
  TERM=TOKL2,
             !.
  
  is_perebor(STR,TERM,STR10):-
  fronttoken(STR,TOK0,TOKl0),
  is_quel(TOK0,STR10),
  TERM=TOKL0,!.
  
  
  is_perebor(_,_,_):-
  write(">> FALSE second frase\n"),	
	fail.

  
 
  tokl(STR,[TOK|TOKL]):-		
  					
  					
	fronttoken(STR,TOK,STR1),	
					
	
	
	check(TOK),			
	!,				
						
	tokl(STR1,TOKL).		
  tokl(_,[]).				

   
  
  
  check(WORD):-				
	is_noun(WORD),
	!.				
  check(WORD):-
	is_det(WORD),
	!.
  check(WORD):-
	is_rel(WORD),
	!.
  check(WORD):-
	is_verb(WORD),
	!.
  check(WORD):-				
	write(">> Unknown word: ",WORD),
	nl.

goal	                                               
  write("Write two sentanses:\n "),				
  write("Example:\n1: every man  loves a woman\n", "2:Every woman loves children\n" ),	
  consult("sen_an.dba",senan_db),  			                             
  readln(STR1),	
  readln(STR2),
  %STR2="every woman loves children",
  %STR1="every man  loves a woman",
  tokl(STR1,TOKL),				
  s_sentence(TOKL,RESTTOKL,sent(_,verbp(_,nounp(_,STR10,_)))),
    nl,
  is_perebor(STR2,Term,STR10),	
  concat(STR1," that ",STR0),
  concat(STR0,TERM,STR3),
  write(STR3,'\n'),					
  tokl(STR3,TOKL1),					
  s_sentence(TOKL1,RESTTOKL,sent(NOUNP1,VERBP1)),			
  RESTTOKL=[],						
  write("Analysis:\n",NOUNP1,'\n',VERBP1).	
				
