/*****************************************************************************

		Copyright (c) 1984 - 2000 Prolog Development Center A/S

 Project:  SEN_AN
 FileName: SEN_AN.PRO
 Purpose: No description
 Written by: Visual Prolog
 Comments:
******************************************************************************/


						%com.:!!!"  ":   !!!
						%com.: ,  "com.:",    
						%com.:     , ..     
						%com.:        ,   
						%com.:    goal.

facts - senan_db 				%com.:        ()
  det(string)
  noun(string)
  rel(string)
  verb(string)

domains						%com.:  
  DETERM	= none;
  		  determ(string)
  NOUNP		= nounp(DETERM,string,RELCL)
  RELCL		= none;
  		  relcl(string,VERBP)
  SENTENCE	= sent(NOUNP,VERBP)
  VERBP		=verb(string);
		  verbp(string,NOUNP)
  TOKL		= string*			%com.:  

predicates					%com.: "" 
% Recognition of words in different forms
  is_det(string)
  is_noun(string)
  is_rel(string)
  is_verb(string)
  is_quel(string)
is_razbor(string,string)
% Parser
  nondeterm s_determ(TOKL,TOKL,DETERM)
  nondeterm s_nounp(TOKL,TOKL,NOUNP)
  nondeterm s_relcl(TOKL,TOKL,RELCL)
  nondeterm s_sentence(TOKL,TOKL,SENTENCE)
  nondeterm s_verbp(TOKL,TOKL,VERBP)

% scanner
  check(string)
  tokl(string,TOKL)
	% 7.1.2005
clauses						%com.:  
						/*com.:   s_*,      .
							         ,   
							  .    -     , 
							-   (,  ).
							        .  
							 :  ,      
							 (  ),  ;    -  . 
							      ,  
							     ,    
							  ,   -  , .. ,     
							.       ,     
							  :   .  */
						


  s_sentence(TOKL,TOKL2,sent(NOUNP,VERBP)):- 	%com.: :    ,  
	s_nounp(TOKL,TOKL1,NOUNP),		%com.:     , 	
	s_verbp(TOKL1,TOKL2,VERBP),		%com.:    -  ,  
	TOKL2=[],				%com.:     ( ).
	!.					%com.: :  ,      . 
  s_sentence(_,_,_):-
	write(">> Sentence not recognized\n"),	%com.:    , ,   .
	fail.

  s_nounp(TOKL,TOKL2,nounp(DETERM,NOUN,RELCL)):-%com.:   -   
	s_determ(TOKL,[NOUN|TOKL1],DETERM),	%com.:  (  ),  
	is_noun(NOUN),				%com.: ,    
	s_relcl(TOKL1,TOKL2,RELCL).		%com.:   ( ).

  s_determ([DETERM|TOKL],TOKL,determ(DETERM)):- %com.: :     
	is_det(DETERM).				%com.: .
  s_determ(TOKL,TOKL,none).			%com.:  -  ,     .

  s_relcl([REL|TOKL],TOKL1,relcl(REL,VERBP)):-	%com.:  :    
	is_rel(REL),				%com.: ,     	
	s_verbp(TOKL,TOKL1,VERBP).		%com.:  .	
  s_relcl(TOKL,TOKL,none).
 	%com.:  ,   .

  s_verbp([VERB|TOKL],TOKL1,verbp(VERB,NOUNP)):-%com.:  :    
	is_verb(VERB),				%com.: ,   
	s_nounp(TOKL,TOKL1,NOUNP),
	 STR10=TOKL1.		%com.:  .
  s_verbp([VERB|TOKL],TOKL,verb(VERB)):-	%com.: ,      
	is_verb(VERB).				%com.: .

  is_noun(X):-				/*com.:  ,     -  */						
	noun(X),			/*com.: , "-,     ,   - "*/
	!.				/*com.: :       ,   */
  is_noun(X):-				/*com.:     */
	noun(Y),			/*com.: " "X"="Y"+"s" - ,  Y - */
	concat(Y,"s",X),
	!.

  is_det(X):-				/*com.: */
	det(X),
	!.
  is_quel(X):-	
  	noun(X),		/*com.: */
	X=STR10,
	!.

  is_rel(X):-				/*com.:*/
	rel(X),
	!.

  is_verb(X):-				/*com.: */
	verb(X),
	!.
  is_verb(X):-				/*com.:,   */
	verb(Y),
	concat(Y,"s",X),
	!.
  is_verb(X):-
	verb(Y),
	concat(Y,"ed",X),
	!.
  is_verb(X):-
	verb(Y),
	concat(Y,"es",X),
	!.
  is_verb(X):-
	verb(Y),
	concat(Y,"ing",X),
	!.
  is_razbor(STR1,STR2):-
	  write("Write two sentanses: "),
  fronttoken(STR2,TOK0,TOKl0),
    is_quel(TOK0),
  concat(STR1," that ",STR0),
  concat(STR0,TOKl0,STR3),
  write(STR3,'\n'),					%com.:  .
  tokl(STR3,TOKL),					%com.:      .
  s_sentence(TOKL,RESTTOKL,SENT),			%com.:  .
  RESTTOKL=[],						%com.:        
  write(SENT),

  !.

  tokl(STR,[TOK|TOKL]):-		/*com.: ,     (list -  ) .
  						 :  ,     
  						  ,      .
  						      .  :
  						  ,     ,
  						      ( ).
  					*/
	fronttoken(STR,TOK,STR1),	/*com.:   fronttoken (STRING String, STRING Token, STRING RestString)
						    String,   - Token,   RestString*/
	
	
	check(TOK),			/*com.: ,     */
	!,				/*com.: :        ,
						 -     */
	tokl(STR1,TOKL).		/*com.:   */
  tokl(_,[]).				/*com.:   */

   
  
  
  check(WORD):-				/*com.:  ,      ,  */
	is_noun(WORD),
	!.				/*com.::  ,    ,   ,  */
  check(WORD):-
	is_det(WORD),
	!.
  check(WORD):-
	is_rel(WORD),
	!.
  check(WORD):-
	is_verb(WORD),
	!.
  check(WORD):-				/*com.:      , ,   */
	write(">> Unknown word: ",WORD),
	nl.

goal	%com.:  Goal   ,   -    .   .
  consult("sen_an.dba",senan_db),			%com.:  ,  .
  write("Try: every man that lives loves a woman\n", "woman loves children\n" ),	%com.:    .
  %write("Write two sentanses: "),				%com.:     .
  %readln(STR1),	
  %readln(STR2),
   STR1 = "every man that lives loves a woman",	
  STR2 = " woman loves children",
  write("rere"),
is_razbor(STR1,STR2),
write("rere"),
  is_razbor(STR1,TOKL0).						%com.:  .
